/*
    fieldlst.h - definizione della classe Fieldlist
    Copyright (c) 1997 Simone Govoni
*/

/*
    Questo header deve essere incluso DOPO i seguenti file:
    dbf.h
*/


#ifndef FIELDLST_H
#define FIELDLST_H

// Fieldlist: lista di indici di campo ////////////////////////////////////

class Fieldlist {
private:
    int *field;     // ptr. al vettore degli indici di campo
    int fieldno;    // massimo numero di indici memorizzabili nella lista
    int top;        // punta al prossimo indice su cui scrivere
    int current;    // punta al prossimo indice di campo da leggere
public:
    Fieldlist(int max=Dbf::MAX_FIELD_NUM);
    // Aggiungi un indice di campo alla lista
    void addfield(int fn);
    // Fa in modo che la prossima lettura agisca sul primo indice memorizzato
    void start(void)
        { current=0; }
    // leggi il prossimo indice di campo; ritorna 0 se siamo gia' alla fine
    int getnext(void)
        { return (current<top ? field[current++] : 0 ); }
    ~Fieldlist()
        { delete [] field; }
};

#endif // FIELDST_H