/*
    applic.h - definizione della classe Application
    Copyright (c) 1997 Simone Govoni
*/

/*
    Questo header deve essere incluso DOPO i seguenti file:
    cmdline.h
*/

#ifndef APPLIC_H
#define APPLIC_H

// Questa classe e' un "contenitore" per applicazioni object-oriented

class Application {
protected:
    Cmdline *cline;
public:
    /*
        cmdargc: stessa semantica della variabile di sistema argc
        cmdargv: stessa semantica della variabile di sistema argv
        cmdopts: stessa sementica della lista degli switch della
                 getopt() AT&T
    */
    Application(int cmdargc,char *cmdargv[],char *cmdopts);
    virtual int main(void)=0;
    virtual ~Application();
};

#endif // APPLIC_H